"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveBatchError = exports.GetBatchErrors = exports.BatchErrorMSSql = void 0;
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function BatchErrorMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.BatchErrorMSSql = BatchErrorMSSql;
function GetBatchErrors(vcc, batchType, batchTypeId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('BatchType', sql.VarChar(25), batchType)
        .input('BatchTypeId', sql.VarChar(50), batchTypeId)
        .execute('GetBatchErrors')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetBatchErrors = GetBatchErrors;
function SaveBatchError(vcc, systemService, batchTypeId, batchTypeName, implementation, interactionId, query, errorFunction, errorMessage, errorDetail) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('SystemService', sql.VarChar(50), systemService)
        .input('BatchTypeId', sql.VarChar(50), batchTypeId)
        .input('BatchTypeName', sql.VarChar(50), batchTypeName)
        .input('Implementation', sql.VarChar(50), implementation)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('Query', sql.VarChar(250), query)
        .input('ErrorFunction', sql.VarChar(100), errorFunction)
        .input('ErrorMessage', sql.VarChar(250), errorMessage)
        .input('ErrorDetail', sql.VarChar(sql.MAX), errorDetail)
        .execute('SaveBatchError')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Executing error ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveBatchError = SaveBatchError;
