"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeleteNeuroLinguisticProgramming = exports.SaveWord = exports.SaveNeuroLinguisticProgramming = exports.GetSystemWords = exports.GetWords = exports.GetNeuroLinguisticProgramming = exports.GetNeuroLinguisticProgrammings = exports.NeuroLinguisticProgrammingMSSql = void 0;
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function NeuroLinguisticProgrammingMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.NeuroLinguisticProgrammingMSSql = NeuroLinguisticProgrammingMSSql;
function GetNeuroLinguisticProgrammings(vcc, search_criteria, search_expression) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .execute('GetNeuroLinguisticProgrammings')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetNeuroLinguisticProgrammings = GetNeuroLinguisticProgrammings;
function GetNeuroLinguisticProgramming(vcc, name, processId, language) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Name', sql.VarChar(50), name)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('Language', sql.VarChar(50), language)
        .execute('GetNeuroLinguisticProgramming')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var neuroLinguisticProgramming = (recordset && recordset.length > 0 ? recordset[0] : null);
        if (neuroLinguisticProgramming) {
            recordset = (recordsets && recordsets.length > 1 ? recordsets[1] : null);
            neuroLinguisticProgramming.words = (recordset ? recordset : null);
        }
        return Promise.resolve(neuroLinguisticProgramming);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetNeuroLinguisticProgramming = GetNeuroLinguisticProgramming;
function GetWords(vcc, search_criteria, search_expression, processId, language) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('Language', sql.VarChar(50), language)
        .execute('GetWords')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetWords = GetWords;
function GetSystemWords(vcc, search_criteria, search_expression, processId, language) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('Language', sql.VarChar(50), language)
        .execute('GetSystemWords')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetSystemWords = GetSystemWords;
function SaveNeuroLinguisticProgramming(vcc, name, description, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Name', sql.VarChar(50), name)
        .input('Description', sql.VarChar(50), description)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .execute('SaveNeuroLinguisticProgramming')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveNeuroLinguisticProgramming = SaveNeuroLinguisticProgramming;
function SaveWord(vcc, neuroLinguisticProgrammingId, name, processId, language, type, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('NeuroLinguisticProgrammingId', sql.VarChar(50), neuroLinguisticProgrammingId)
        .input('Name', sql.VarChar(50), name)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('Language', sql.VarChar(50), language)
        .input('Type', sql.VarChar(50), type)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .execute('SaveWord')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveWord = SaveWord;
function DeleteNeuroLinguisticProgramming(vcc, name, processId, language) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Name', sql.VarChar(50), name)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('Language', sql.VarChar(50), language)
        .execute('DeleteNeuroLinguisticProgramming')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteNeuroLinguisticProgramming = DeleteNeuroLinguisticProgramming;
