"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Item = exports.TemplateByAPI = exports.GenericTemplateQuery = exports.TemplateThemeItemEntity = exports.TemplateThemeItem = exports.TemplateTheme = exports.Template = void 0;
var Template = (function () {
    function Template(type, name, description, template, category, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.type = type;
        this.name = name;
        this.description = description;
        this.template = template;
        this.category = category;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.selected = false;
        this.templateThemes = [];
        this.templateThemeItems = [];
        this.genericTemplateQueries = [];
        this.modelLanguages = null;
    }
    return Template;
}());
exports.Template = Template;
var TemplateTheme = (function () {
    function TemplateTheme(templateId, id, order, description, category1, category2, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.templateId = templateId;
        this.id = id;
        this.order = order;
        this.description = description;
        this.category1 = category1;
        this.category2 = category2;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.selected = false;
        this.items = [];
        this.isNegative = false;
        this.analysisType = 'SEMANTIC';
    }
    return TemplateTheme;
}());
exports.TemplateTheme = TemplateTheme;
var TemplateThemeItem = (function () {
    function TemplateThemeItem(templateId, templateThemeId, id, query, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.templateId = templateId;
        this.templateThemeId = templateThemeId;
        this.id = id;
        this.query = query;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.selected = false;
        this.acceptancePercentage = 0;
        this.order = null;
    }
    return TemplateThemeItem;
}());
exports.TemplateThemeItem = TemplateThemeItem;
var TemplateThemeItemEntity = (function () {
    function TemplateThemeItemEntity() {
        this.templateId = null;
        this.templateThemeId = null;
        this.templateThemeItemId = null;
        this.entityId = null;
        this.entityName = null;
        this.acceptancePercentage = 0;
        this.order = null;
        this.createdDate = null;
        this.createdByUserId = null;
        this.lastModifiedDate = null;
        this.lastModifiedByUserId = null;
    }
    return TemplateThemeItemEntity;
}());
exports.TemplateThemeItemEntity = TemplateThemeItemEntity;
var GenericTemplateQuery = (function () {
    function GenericTemplateQuery(templateId, id, query, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.templateId = templateId;
        this.id = id;
        this.query = query;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.selected = false;
    }
    return GenericTemplateQuery;
}());
exports.GenericTemplateQuery = GenericTemplateQuery;
var TemplateByAPI = (function () {
    function TemplateByAPI(name, description, template, category, type, items, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.name = name;
        this.description = description;
        this.template = template;
        this.category = category;
        this.type = type;
        this.items = items;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.templateThemes = [];
        this.templateThemeItems = [];
    }
    return TemplateByAPI;
}());
exports.TemplateByAPI = TemplateByAPI;
var Item = (function () {
    function Item(item, order, type, query, items) {
        this.item = item;
        this.order = order;
        this.type = type;
        this.query = query;
        this.items = items;
    }
    return Item;
}());
exports.Item = Item;
