"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BatchFinished = exports.PreBatchSummary = exports.BatchManage = exports.BatchError = exports.BatchDetail = exports.Batch = void 0;
var Batch = (function () {
    function Batch(installationId, vcc, batchTypeName, batchTypeId) {
        if (installationId === void 0) { installationId = null; }
        if (vcc === void 0) { vcc = null; }
        if (batchTypeName === void 0) { batchTypeName = null; }
        if (batchTypeId === void 0) { batchTypeId = null; }
        this.installationId = installationId;
        this.vcc = vcc;
        this.batchTypeName = batchTypeName;
        this.batchTypeId = batchTypeId;
    }
    return Batch;
}());
exports.Batch = Batch;
var BatchDetail = (function () {
    function BatchDetail(vcc, batchTypeName, batchTypeId, description, percentage, status, statusDescription) {
        if (vcc === void 0) { vcc = null; }
        if (batchTypeName === void 0) { batchTypeName = null; }
        if (batchTypeId === void 0) { batchTypeId = null; }
        if (description === void 0) { description = null; }
        if (percentage === void 0) { percentage = null; }
        if (status === void 0) { status = null; }
        if (statusDescription === void 0) { statusDescription = null; }
        this.vcc = vcc;
        this.batchTypeName = batchTypeName;
        this.batchTypeId = batchTypeId;
        this.description = description;
        this.percentage = percentage;
        this.status = status;
        this.statusDescription = statusDescription;
    }
    return BatchDetail;
}());
exports.BatchDetail = BatchDetail;
var BatchError = (function () {
    function BatchError() {
        this.vcc = null;
        this.batchType = null;
        this.batchTypeId = null;
        this.batchTypeName = null;
        this.implementation = null;
        this.interactionId = null;
        this.query = null;
        this.errorFunction = null;
        this.errorMessage = null;
        this.errorDetail = null;
    }
    BatchError.prototype.SetErrorData = function (errorFunction, errorMessage, errorDetail) {
        if (!this.errorFunction)
            this.errorFunction = errorFunction;
        if (!this.errorMessage)
            this.errorMessage = errorMessage;
        if (!this.errorDetail)
            this.errorDetail = typeof errorDetail === 'string' ? errorDetail : JSON.stringify(errorDetail);
    };
    BatchError.prototype.CleanErrorData = function () {
        this.errorFunction = null;
        this.errorMessage = null;
        this.errorDetail = null;
    };
    return BatchError;
}());
exports.BatchError = BatchError;
var BatchManage = (function () {
    function BatchManage(vcc, batchTypeName, batchTypeId, systemService, status, statusDescription, user, comment) {
        if (vcc === void 0) { vcc = null; }
        if (batchTypeName === void 0) { batchTypeName = null; }
        if (batchTypeId === void 0) { batchTypeId = null; }
        if (systemService === void 0) { systemService = null; }
        if (status === void 0) { status = null; }
        if (statusDescription === void 0) { statusDescription = null; }
        if (user === void 0) { user = null; }
        if (comment === void 0) { comment = null; }
        this.vcc = vcc;
        this.batchTypeName = batchTypeName;
        this.batchTypeId = batchTypeId;
        this.systemService = systemService;
        this.status = status;
        this.statusDescription = statusDescription;
        this.user = user;
        this.comment = comment;
    }
    return BatchManage;
}());
exports.BatchManage = BatchManage;
var PreBatchSummary = (function () {
    function PreBatchSummary(installationId, vcc, totalAudio, durationTime, roundedTime, inProcessAudio, inProcessDurationTime, alreadyTranscribedAudio, alreadyDurationTime, alreadyRoundedDurationTime, alreadyTranscribedDurationTime, alreadyTranscribedRoundedDurationTime, totalQueries, totalModels, modelRequests, batchTypeName, batchTypeId, processId, templateId, userApi, startDate) {
        if (installationId === void 0) { installationId = null; }
        if (vcc === void 0) { vcc = null; }
        if (totalAudio === void 0) { totalAudio = 0; }
        if (durationTime === void 0) { durationTime = 0; }
        if (roundedTime === void 0) { roundedTime = 0; }
        if (inProcessAudio === void 0) { inProcessAudio = 0; }
        if (inProcessDurationTime === void 0) { inProcessDurationTime = 0; }
        if (alreadyTranscribedAudio === void 0) { alreadyTranscribedAudio = 0; }
        if (alreadyDurationTime === void 0) { alreadyDurationTime = 0; }
        if (alreadyRoundedDurationTime === void 0) { alreadyRoundedDurationTime = 0; }
        if (alreadyTranscribedDurationTime === void 0) { alreadyTranscribedDurationTime = 0; }
        if (alreadyTranscribedRoundedDurationTime === void 0) { alreadyTranscribedRoundedDurationTime = 0; }
        if (totalQueries === void 0) { totalQueries = 0; }
        if (totalModels === void 0) { totalModels = 0; }
        if (modelRequests === void 0) { modelRequests = 0; }
        if (batchTypeName === void 0) { batchTypeName = null; }
        if (batchTypeId === void 0) { batchTypeId = null; }
        if (processId === void 0) { processId = null; }
        if (templateId === void 0) { templateId = null; }
        if (userApi === void 0) { userApi = null; }
        this.installationId = installationId;
        this.vcc = vcc;
        this.totalAudio = totalAudio;
        this.durationTime = durationTime;
        this.roundedTime = roundedTime;
        this.inProcessAudio = inProcessAudio;
        this.inProcessDurationTime = inProcessDurationTime;
        this.alreadyTranscribedAudio = alreadyTranscribedAudio;
        this.alreadyDurationTime = alreadyDurationTime;
        this.alreadyRoundedDurationTime = alreadyRoundedDurationTime;
        this.alreadyTranscribedDurationTime = alreadyTranscribedDurationTime;
        this.alreadyTranscribedRoundedDurationTime = alreadyTranscribedRoundedDurationTime;
        this.totalQueries = totalQueries;
        this.totalModels = totalModels;
        this.modelRequests = modelRequests;
        this.batchTypeName = batchTypeName;
        this.batchTypeId = batchTypeId;
        this.processId = processId;
        this.templateId = templateId;
        this.userApi = userApi;
        this.startDate = startDate;
        this.totalInteraction = 0;
        this.totalSync = 0;
        this.totalAsync = 0;
        this.totalAsyncDetail = 0;
        this.totalCallPhrases = 0;
        this.alreadyCallPhrases = 0;
        this.totalTextPhrases = 0;
        this.alreadyTextPhrases = 0;
    }
    return PreBatchSummary;
}());
exports.PreBatchSummary = PreBatchSummary;
var BatchFinished = (function () {
    function BatchFinished(vcc, batchTypeName, batchTypeId, closedDate) {
        if (vcc === void 0) { vcc = null; }
        if (batchTypeName === void 0) { batchTypeName = null; }
        if (batchTypeId === void 0) { batchTypeId = null; }
        this.vcc = vcc;
        this.batchTypeName = batchTypeName;
        this.batchTypeId = batchTypeId;
        this.closedDate = closedDate;
        this.batchId = null;
    }
    return BatchFinished;
}());
exports.BatchFinished = BatchFinished;
